package com.poststats.golf.rs.api;

import io.swagger.v3.oas.annotations.OpenAPIDefinition;
import io.swagger.v3.oas.annotations.enums.SecuritySchemeType;
import io.swagger.v3.oas.annotations.info.Contact;
import io.swagger.v3.oas.annotations.info.Info;
import io.swagger.v3.oas.annotations.security.SecurityScheme;
import jakarta.ws.rs.Path;

/**
 * @author brian.long@poststats.com
 */
@Path("/")
@OpenAPIDefinition(
		info = @Info(
				contact = @Contact(name = "Brian Long", email = "brian.long@poststats.com"),
				title = "PostStats Golf API",
				description = "An API providing access to PostStats Golf objects.",
				version = "v1"
		)
)
@SecurityScheme(name = "basic", type = SecuritySchemeType.HTTP, scheme = "BASIC")
public interface BaseApi {

}
