package com.poststats.golf.rs.api;

import java.util.List;

import com.poststats.golf.rs.api.model.Round;

import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.validation.constraints.NotNull;
import jakarta.validation.constraints.Positive;
import jakarta.ws.rs.GET;
import jakarta.ws.rs.Path;
import jakarta.ws.rs.Produces;
import jakarta.ws.rs.QueryParam;

/**
 * @author brian.long@poststats.com
 */
@Path("/golf/rounds")
@Tag(name = "Round API")
@ApiResponses({
		@ApiResponse(responseCode = "200", description = "Success"),
		@ApiResponse(responseCode = "400", description = "A query parameter is not valid"),
		@ApiResponse(responseCode = "404", description = "No matching rounds were found")
})
public interface RoundsApi {

	// FIXME String to LocalDate
	@GET
	@Path("/byDate")
	@Produces(Constants.V1_JSON)
	@Operation(summary = "Finds rounds before a date.", description = "Searches for rounds by date, exclusive.")
	List<Round> findByDate(@NotNull @Positive @QueryParam("personId") long personId,
			@QueryParam("cutoffDate") String cutoffDate);

}
