package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class BaseCourseTee<ConcreteT extends BaseCourseTee<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty
	@MapEntry("tee")
	private String name;

	@JsonProperty
	@MapEntry("teeColor")
	private String color;

	@JsonProperty
	@MapEntry("primaryGender")
	private char primaryGender;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getColor() {
		return color;
	}

	public void setColor(String color) {
		this.color = color;
	}

	public char getPrimaryGender() {
		return primaryGender;
	}

	public void setPrimaryGender(char gender) {
		this.primaryGender = gender;
	}

	public ConcreteT withName(String name) {
		this.name = name;
		return this.withThis();
	}

	public ConcreteT withColor(String color) {
		this.color = color;
		return this.withThis();
	}

	public ConcreteT withPrimaryGender(char gender) {
		this.primaryGender = gender;
		return this.withThis();
	}

}
