package com.poststats.golf.rs.api.model;

import java.time.LocalDate;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class BaseEventDocument<ConcreteT extends BaseEventDocument<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty
	@MapEntry
	private String type;

	@JsonProperty
	@MapEntry
	private LocalDate day;

	@JsonProperty
	@MapEntry("liveline")
	private LocalDate publicationDate;

	@JsonProperty
	@MapEntry
	private boolean sendEmailWithLink;

	@JsonProperty
	@MapEntry
	private boolean sendEmailWithContent;

	@JsonProperty
	@MapEntry
	private boolean sendTextWithLink;

	@JsonProperty
	@MapEntry
	private boolean sendTextWithContent;

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}

	public LocalDate getDay() {
		return day;
	}

	public void setDay(LocalDate day) {
		this.day = day;
	}

	public LocalDate getPublicationDate() {
		return publicationDate;
	}

	public void setPublicationDate(LocalDate publicationDate) {
		this.publicationDate = publicationDate;
	}

	public boolean isSendEmailWithLink() {
		return sendEmailWithLink;
	}

	public void setSendEmailWithLink(boolean sendEmailWithLink) {
		this.sendEmailWithLink = sendEmailWithLink;
	}

	public boolean isSendEmailWithContent() {
		return sendEmailWithContent;
	}

	public void setSendEmailWithContent(boolean sendEmailWithContent) {
		this.sendEmailWithContent = sendEmailWithContent;
	}

	public boolean isSendTextWithLink() {
		return sendTextWithLink;
	}

	public void setSendTextWithLink(boolean sendTextWithLink) {
		this.sendTextWithLink = sendTextWithLink;
	}

	public boolean isSendTextWithContent() {
		return sendTextWithContent;
	}

	public void setSendTextWithContent(boolean sendTextWithContent) {
		this.sendTextWithContent = sendTextWithContent;
	}

	public ConcreteT withDay(LocalDate day) {
		this.day = day;
		return this.withThis();
	}

	public ConcreteT withPublicationDate(LocalDate publicationDate) {
		this.publicationDate = publicationDate;
		return this.withThis();
	}

	public ConcreteT withSendEmailWithLink(boolean sendEmailWithLink) {
		this.sendEmailWithLink = sendEmailWithLink;
		return this.withThis();
	}

	public ConcreteT withSendEmailWithContent(boolean sendEmailWithContent) {
		this.sendEmailWithContent = sendEmailWithContent;
		return this.withThis();
	}

	public ConcreteT withSendTextWithLink(boolean sendTextWithLink) {
		this.sendTextWithLink = sendTextWithLink;
		return this.withThis();
	}

	public ConcreteT withSendTextWithContent(boolean sendTextWithContent) {
		this.sendTextWithContent = sendTextWithContent;
		return this.withThis();
	}

}
