package com.poststats.golf.rs.api.model;

import java.time.LocalTime;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class BaseEventRoundPairing<ConcreteT extends BaseEventRoundPairing<ConcreteT>>
		extends BaseModel<ConcreteT> {

	@JsonProperty
	@MapEntry
	private LocalTime teetime;

	@JsonProperty
	@MapEntry("number")
	private Short holeNumber;

	public LocalTime getTeetime() {
		return teetime;
	}

	public void setTeetime(LocalTime teetime) {
		this.teetime = teetime;
	}

	public Short getHoleNumber() {
		return holeNumber;
	}

	public void setHoleNumber(Short holeNumber) {
		this.holeNumber = holeNumber;
	}

	public ConcreteT withTeetime(LocalTime teetime) {
		this.teetime = teetime;
		return this.withThis();
	}

	public ConcreteT withHoleNumber(Short holeNumber) {
		this.holeNumber = holeNumber;
		return this.withThis();
	}

}
