package com.poststats.golf.rs.api.model;

import java.time.Year;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class BaseGolfer<ConcreteT extends BaseGolfer<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty
	@MapEntry
	private Year started;

	@JsonProperty
	@MapEntry("aStrokeHandicap")
	private Float strokeHandicap;

	public Year getStarted() {
		return started;
	}

	public void setStarted(Year started) {
		this.started = started;
	}

	public Float getStrokeHandicap() {
		return strokeHandicap;
	}

	public void setStrokeHandicap(Float strokeHandicap) {
		this.strokeHandicap = strokeHandicap;
	}

	public ConcreteT withStarted(Year started) {
		this.started = started;
		return this.withThis();
	}

	public ConcreteT withStrokeHandicap(Float strokeHandicap) {
		this.strokeHandicap = strokeHandicap;
		return this.withThis();
	}

}
