package com.poststats.golf.rs.api.model;

import java.time.LocalDate;
import java.time.LocalTime;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

@JsonIgnoreProperties(ignoreUnknown = true)
public abstract class BaseRound<ConcreteT extends BaseRound<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty
	@MapEntry
	private LocalDate teedate;

	@JsonProperty
	@MapEntry
	private LocalTime teetime;

	public LocalDate getTeedate() {
		return teedate;
	}

	public void setTeedate(LocalDate teedate) {
		this.teedate = teedate;
	}

	public LocalTime getTeetime() {
		return teetime;
	}

	public void setTeetime(LocalTime teetime) {
		this.teetime = teetime;
	}

	public ConcreteT withTeedate(LocalDate teedate) {
		this.teedate = teedate;
		return this.withThis();
	}

	public ConcreteT withTeetime(LocalTime teetime) {
		this.teetime = teetime;
		return this.withThis();
	}

}
