package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.BaseModel;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class BaseSeries<ConcreteT extends BaseSeries<ConcreteT>> extends BaseModel<ConcreteT> {

	@JsonProperty(required = true)
	@MapEntry("series")
	private String name;

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public ConcreteT withName(String name) {
		this.name = name;
		return this.withThis();
	}

}
