package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class EventDocument extends BaseEventDocument<EventDocument> implements ReferenceableEventDocument {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("documentID")
	private long id;

	@JsonProperty
	@MapEntry
	private Event event;

	@JsonProperty
	@MapEntry("eventID")
	private Long eventId;

	@Override
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public Event getEvent() {
		return event;
	}

	public void setEvent(Event event) {
		this.event = event;
	}

	public Long getEventId() {
		return eventId;
	}

	public void setEventId(Long eventId) {
		this.eventId = eventId;
	}

	public EventDocument withId(long id) {
		this.id = id;
		return this;
	}

	public EventDocument withEvent(Event event) {
		this.event = event;
		return this;
	}

	public EventDocument withEventId(Long eventId) {
		this.eventId = eventId;
		return this;
	}

}
