package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class EventRound extends BaseEventRound<EventRound> implements ReferenceableEventRound {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("eroundID")
	private long id;

	@JsonProperty
	@MapEntry
	private Course course;

	@JsonProperty
	@MapEntry("courseID")
	private Integer courseId;

	@Override
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public Course getCourse() {
		return course;
	}

	public void setCourse(Course course) {
		this.course = course;
	}

	public Integer getCourseId() {
		return courseId;
	}

	public void setCourseId(Integer courseId) {
		this.courseId = courseId;
	}

	public EventRound withId(long id) {
		this.id = id;
		return this;
	}

	public EventRound withCourse(Course course) {
		this.course = course;
		return this;
	}

	public EventRound withCourseId(Integer courseId) {
		this.courseId = courseId;
		return this;
	}

}
