package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class EventRoundPairing extends BaseEventRoundPairing<EventRoundPairing> implements ReferenceableEventRound {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("pairingID")
	private long id;

	@JsonProperty
	@MapEntry
	private EventRound round;

	@JsonProperty
	@MapEntry("eroundID")
	private Long eroundId;

	@JsonProperty
	@MapEntry
	private Course course;

	@JsonProperty
	@MapEntry("courseID")
	private Integer courseId;

	@JsonProperty
	@MapEntry("nine")
	private CourseNine courseNine;

	@JsonProperty
	@MapEntry("nineID")
	private Long courseNineId;

	@Override
	public long getId() {
		return id;
	}

	public void setId(long id) {
		this.id = id;
	}

	public EventRound getRound() {
		return round;
	}

	public void setRound(EventRound round) {
		this.round = round;
	}

	public Long getEroundId() {
		return eroundId;
	}

	public void setEroundId(Long eroundId) {
		this.eroundId = eroundId;
	}

	public Course getCourse() {
		return course;
	}

	public void setCourse(Course course) {
		this.course = course;
	}

	public Integer getCourseId() {
		return courseId;
	}

	public void setCourseId(Integer courseId) {
		this.courseId = courseId;
	}

	public CourseNine getCourseNine() {
		return courseNine;
	}

	public void setCourseNine(CourseNine courseNine) {
		this.courseNine = courseNine;
	}

	public Long getCourseNineId() {
		return courseNineId;
	}

	public void setCourseNineId(Long courseNineId) {
		this.courseNineId = courseNineId;
	}

	public EventRoundPairing withId(long id) {
		this.id = id;
		return this;
	}

	public EventRoundPairing withRound(EventRound round) {
		this.round = round;
		return this;
	}

	public EventRoundPairing withRoundId(Long eroundId) {
		this.eroundId = eroundId;
		return this;
	}

	public EventRoundPairing withCourse(Course course) {
		this.course = course;
		return this;
	}

	public EventRoundPairing withCourseId(Integer courseId) {
		this.courseId = courseId;
		return this;
	}

	public EventRoundPairing withCourseNine(CourseNine courseNine) {
		this.courseNine = courseNine;
		return this;
	}

	public EventRoundPairing withCourseNineId(Long courseNineId) {
		this.courseNineId = courseNineId;
		return this.withThis();
	}

}
