package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;
import com.poststats.rs.api.model.Person;
import com.poststats.rs.api.model.ReferenceablePerson;

@JsonIgnoreProperties(ignoreUnknown = true)
public class Golfer extends BaseGolfer<Golfer> implements ReferenceablePerson {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("personID")
	private long personId;

	@JsonProperty
	@MapEntry("unofficialStrokeHandicap")
	private Float poststatsStrokeHandicap;

	@JsonProperty
	@MapEntry("officialStrokeHandicap")
	private Float usgaStrokeHandicap;

	@JsonProperty
	@MapEntry
	private Person person;

	@Override
	public long getId() {
		return personId;
	}

	public void setId(long personId) {
		this.personId = personId;
	}

	public Float getPoststatsStrokeHandicap() {
		return poststatsStrokeHandicap;
	}

	public void setPoststatsStrokeHandicap(Float poststatsStrokeHandicap) {
		this.poststatsStrokeHandicap = poststatsStrokeHandicap;
	}

	public Float getUsgaStrokeHandicap() {
		return usgaStrokeHandicap;
	}

	public void setUsgaStrokeHandicap(Float usgaStrokeHandicap) {
		this.usgaStrokeHandicap = usgaStrokeHandicap;
	}

	public Person getPerson() {
		return person;
	}

	public void setPerson(Person person) {
		this.person = person;
	}

	public Golfer withId(long personId) {
		this.personId = personId;
		return this;
	}

	public Golfer withPoststatsStrokeHandicap(Float poststatsStrokeHandicap) {
		this.poststatsStrokeHandicap = poststatsStrokeHandicap;
		return this;
	}

	public Golfer withUsgaStrokeHandicap(Float usgaStrokeHandicap) {
		this.usgaStrokeHandicap = usgaStrokeHandicap;
		return this;
	}

	public Golfer withPerson(Person person) {
		this.person = person;
		return this;
	}

}
