package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;

@JsonIgnoreProperties(ignoreUnknown = true)
public class ReferencedCourse implements ReferenceableCourse {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("courseID")
	private int id;

	@Override
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public ReferencedCourse withId(int id) {
		this.id = id;
		return this;
	}

}
