package com.poststats.golf.rs.api.model;

import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import com.poststats.rs.api.annotation.MapEntry;

/**
 * @author brian.long@poststats.com
 */
@JsonIgnoreProperties(ignoreUnknown = true)
public class Series extends BaseSeries<Series> implements ReferenceableSeries {

	@JsonProperty(required = true, access = Access.READ_ONLY)
	@MapEntry("seriesID")
	private int id;

	@Override
	public int getId() {
		return id;
	}

	public void setId(int id) {
		this.id = id;
	}

	public Series withId(int id) {
		this.id = id;
		return this;
	}

}
